/*
   Generated by EX4-TO-MQ4 decompiler V4.0.224.1 []
   Website: http://purebeam.biz
   E-mail : purebeam@gmail.com
*/
#property copyright "FX Ultimatum"
#property link      ""

#property indicator_separate_window

int g_bars_76 = 0;
int gi_80 = 0;
int gi_84 = 0;
double gd_88;
double gd_96;
double gd_104;
double gd_112;
double gd_120;
double gd_128;

int init() {
   IndicatorShortName("Entry Signal");
   return (0);
}

int deinit() {
   ObjectDelete("HL6_TEXT1");
   ObjectDelete("HL6_TEXT2");
   ObjectDelete("HL6_TEXT3");
   ObjectDelete("HL6_TEXT4");
   return (0);
}

int start() {
   double lda_8[10];
   GetEMA(lda_8);
   int l_timeframe_0 = Period();
   int li_4 = GetTrendTimeFrame(l_timeframe_0);
   if (li_4 == -1) {
      Comment("Entry Detector only works on 4H, Daily, Weekly Timeframe");
      PlaySound("alert.wav");
      return (0);
   }
   if (g_bars_76 != Bars) {
      ObjectDelete("HL6_TEXT1");
      ObjectDelete("HL6_TEXT2");
      ObjectDelete("HL6_TEXT3");
      ObjectDelete("HL6_TEXT4");
      if (gi_80 == 0 && gi_84 == 0) SetSignal("No Entry Signal Detected", Yellow, 1);
      else SetSignal("Trade Monitoring In Service", Yellow, 1);
   }
   CheckBuyState(l_timeframe_0, li_4, lda_8);
   CheckSellState(l_timeframe_0, li_4, lda_8);
   return (0);
}

int GetTrendTimeFrame(int ai_0) {
   if (ai_0 == 240) return (1440);
   if (ai_0 == 1440) return (10080);
   if (ai_0 == 10080) return (43200);
   return (-1);
}

void GetEMA(double &ada_0[10]) {
   double l_ima_8;
   for (int li_4 = 0; li_4 < 10; li_4++) {
      l_ima_8 = iMA(Symbol(), Period(), 21, 0, MODE_EMA, PRICE_CLOSE, li_4);
      ada_0[li_4] = l_ima_8;
   }
}

void CheckBuyState(int ai_0, int ai_4, double ada_8[10]) {
   string ls_12;
   double l_iatr_20;
   double lda_28[300];
   double lda_32[300];
   double lda_36[300];
   double lda_40[300];
   double lda_44[300];
   double lda_48[300];
   Omoi(lda_40, lda_44, lda_48, ai_4);
   if (gi_80 == 0) {
      if (lda_48[0] > 0.0) {
         Omoi(lda_28, lda_32, lda_36, ai_0);
         if (lda_36[3] < 0.0 && lda_36[2] < 0.0 && lda_36[1] > 0.0) {
            gi_80 = 1;
            l_iatr_20 = iATR(Symbol(), Period(), 50, 0);
            gd_88 = Open[0] - l_iatr_20;
            gd_96 = Open[0] + l_iatr_20;
            gd_104 = Open[0] + 2.0 * l_iatr_20;
            ls_12 = "Buy Signal Detected. Open 2 lots on " + Symbol() + " at " + DoubleToStr(Open[0], Digits);
            SetSignal(ls_12, Blue, 1);
            Alert(ls_12);
            PlaySound("alert.wav");
            SetSignal("Stop Loss: " + DoubleToStr(gd_88, Digits), Red, 2);
            SetSignal("First Profit Target: " + DoubleToStr(gd_96, Digits), Lime, 3);
            SetSignal("Second Profit Target: " + DoubleToStr(gd_104, Digits), Lime, 4);
         }
      }
   }
   if (gi_80 >= 1 && Bid <= gd_88) {
      gd_88 = 0;
      gd_96 = 0;
      gd_104 = 0;
      gi_80 = 0;
      SetSignal("Exit Your Trade. Stop Loss For Buy Signal Hit", Red, 1);
      PlaySound("alert.wav");
   }
   if (gi_80 == 1 && Bid >= gd_96) {
      gi_80 = 2;
      SetSignal("First Profit Target Hit. Exit The First Lot", Lime, 1);
   }
   if (gi_80 >= 1 && Bid >= gd_104) {
      gi_80 = 0;
      SetSignal("Second Profit Target Hit. Exit The Second Lot", Lime, 1);
   }
   if (Close[1] < ada_8[1] && gi_80 >= 2) {
      gi_80 = 0;
      SetSignal("Exit All Opening Positions", Red, 1);
      PlaySound("alert.wav");
   }
}

void CheckSellState(int ai_0, int ai_4, double ada_8[10]) {
   string ls_12;
   double l_iatr_20;
   double lda_28[300];
   double lda_32[300];
   double lda_36[300];
   double lda_40[300];
   double lda_44[300];
   double lda_48[300];
   Omoi(lda_40, lda_44, lda_48, ai_4);
   if (gi_84 == 0) {
      if (lda_48[0] <= 0.0) {
         Omoi(lda_28, lda_32, lda_36, ai_0);
         if (lda_36[3] > 0.0 && lda_36[2] > 0.0 && lda_36[1] < 0.0) {
            gi_84 = 1;
            l_iatr_20 = iATR(Symbol(), Period(), 50, 0);
            gd_112 = Open[0] + l_iatr_20;
            gd_120 = Open[0] - l_iatr_20;
            gd_128 = Open[0] - 2.0 * l_iatr_20;
            ls_12 = "Sell Signal Detected. Open 2 lots on " + Symbol() + " at " + DoubleToStr(Open[0], Digits);
            SetSignal(ls_12, Fuchsia, 1);
            Alert(ls_12);
            PlaySound("alert.wav");
            SetSignal("Stop Loss: " + DoubleToStr(gd_112, Digits), Red, 2);
            SetSignal("First Profit Target: " + DoubleToStr(gd_120, Digits), Violet, 3);
            SetSignal("Second Profit Target: " + DoubleToStr(gd_128, Digits), Violet, 4);
         }
      }
   }
   if (gi_84 >= 1 && Ask >= gd_112) {
      gi_84 = 0;
      gd_112 = 0;
      gd_120 = 0;
      gd_128 = 0;
      SetSignal("Exit Your Trade. Stop Loss For Sell Signal Hit", Red, 1);
      PlaySound("alert.wav");
   }
   if (gi_84 == 1 && Ask <= gd_120) {
      gi_84 = 2;
      SetSignal("First Profit Target Hit. Exit The First Lot", Fuchsia, 1);
      PlaySound("alert.wav");
   }
   if (gi_84 >= 1 && Ask <= gd_128) {
      gi_84 = 0;
      SetSignal("Second Profit Target Hit. Exit The Second Lot", Fuchsia, 1);
      PlaySound("alert.wav");
   }
   if (Close[1] > ada_8[1] && gi_84 >= 2) {
      gi_84 = 0;
      SetSignal("Exit All Opening Positions", Red, 1);
      PlaySound("alert.wav");
   }
}

void SetSignal(string a_text_0, color a_color_8, int ai_12) {
   switch (ai_12) {
   case 1:
      if (ObjectFind("HL6_TEXT1") < 0) {
         ObjectCreate("HL6_TEXT1", OBJ_LABEL, WindowFind("Entry Signal"), 0, 0);
         ObjectSet("HL6_TEXT1", OBJPROP_XDISTANCE, 20);
         ObjectSet("HL6_TEXT1", OBJPROP_YDISTANCE, 20);
      }
      ObjectSetText("HL6_TEXT1", a_text_0, 14, "Georgia", a_color_8);
      break;
   case 2:
      if (ObjectFind("HL6_TEXT2") < 0) {
         ObjectCreate("HL6_TEXT2", OBJ_LABEL, WindowFind("Entry Signal"), 0, 0);
         ObjectSet("HL6_TEXT2", OBJPROP_XDISTANCE, 20);
         ObjectSet("HL6_TEXT2", OBJPROP_YDISTANCE, 40);
      }
      ObjectSetText("HL6_TEXT2", a_text_0, 14, "Georgia", a_color_8);
      break;
   case 3:
      if (ObjectFind("HL6_TEXT3") < 0) {
         ObjectCreate("HL6_TEXT3", OBJ_LABEL, WindowFind("Entry Signal"), 0, 0);
         ObjectSet("HL6_TEXT3", OBJPROP_XDISTANCE, 20);
         ObjectSet("HL6_TEXT3", OBJPROP_YDISTANCE, 60);
      }
      ObjectSetText("HL6_TEXT3", a_text_0, 14, "Georgia", a_color_8);
      break;
   case 4:
      if (ObjectFind("HL6_TEXT4") < 0) {
         ObjectCreate("HL6_TEXT4", OBJ_LABEL, WindowFind("Entry Signal"), 0, 0);
         ObjectSet("HL6_TEXT4", OBJPROP_XDISTANCE, 20);
         ObjectSet("HL6_TEXT4", OBJPROP_YDISTANCE, 80);
      }
      ObjectSetText("HL6_TEXT4", a_text_0, 14, "Georgia", a_color_8);
   }
   g_bars_76 = Bars;
}

void Omoi(double &ada_0[300], double &ada_4[300], double &ada_8[300], int a_timeframe_12) {
   double ld_20 = 0.1818181818;
   double ld_28 = 1.0 - ld_20;
   int li_16 = 300;
   for (int li_36 = li_16; li_36 >= 0; li_36--) {
      ada_0[li_36] = iMA(NULL, a_timeframe_12, 14, 0, MODE_EMA, PRICE_CLOSE, li_36) - iMA(NULL, a_timeframe_12, 27, 0, MODE_EMA, PRICE_CLOSE, li_36);
      ada_4[li_36] = ld_20 * ada_0[li_36] + ld_28 * (ada_4[li_36 + 1]);
      ada_8[li_36] = 2.0 * (ada_0[li_36] - ada_4[li_36]);
   }
}
